package com.sunmi.demo.merch_data;

import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.web.client.RestTemplate;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sunmi.demo.merch_data.utils.MD5;

public class AppTest {
	public static void main(String[] args) {
		// 上传门店信息
	 	postStore();
		//上传交易数据
		postTrade();

	}
	
	
	/**
	 * 上传门店信息
	 */
	public static void  postStore() {
        String channelCode = "xxx";//通过对接人获取渠道号
        String key = "xxxxxx";//通过对接人获取加密签
        String url = "http://test.webapi.engine.sunmi.com/software/postStore";

        try {
            TreeMap<Object, Object> treeMap = new TreeMap<Object, Object>();
            treeMap.put("channel_code", channelCode);//标识第三方
            treeMap.put("request_number", "MKB"+System.currentTimeMillis());//用来匹配请求的 唯一
            treeMap.put("timestamp", (System.currentTimeMillis()/1000));//当前unix时间戳 10位的 秒

            treeMap.put("store_name", "中文名店名称");//门店名称
            treeMap.put("mobile", "12312341234");//手机号
            treeMap.put("contactor", "中文联系人");//联系人
            treeMap.put("address", "我是中文");//地址
            treeMap.put("status", "1");//状态

            String sign = buildParamSign(treeMap,key);//表单数据拼接，计算签名
            treeMap.put("sign",sign);//请求签名用来验证请求的合法性

            JSONObject jsonObject = (JSONObject)JSONObject.toJSON(treeMap);
            String str = postForJson(url,jsonObject);

            System.out.println(str);
            JSONObject resJson = (JSONObject) JSON.parse(str);
            System.out.println(resJson.getString("code"));
            System.out.println(resJson.getString("message"));
            System.out.println(resJson.getString("request_number"));
            System.out.println(resJson.getString("store_code"));

        }catch (Exception e){
            e.printStackTrace();
        }
	}
	
	
	
	
	
	
	/**
	 * 上传交易数据
	 */
    public static void postTrade(){
        String channelCode = "xxx";//通过对接人获取渠道号
        String key = "xxxxxx";//通过对接人获取加密签
        String url = "http://test.webapi.engine.sunmi.com/software/postTrade";

        try {
            List<GoodDetail> list = new ArrayList<GoodDetail>();
            GoodDetail detail1 = new GoodDetail();
            detail1.setGood_spec("111");//商品编码
            detail1.setGood_name(URLEncoder.encode("商品名称123", "utf-8"));//商品名称
            detail1.setGood_num("1");//商品数量
            detail1.setStock_num("");//该商品库存数量
            list.add(detail1);
            String goodDetailStr = JSONArray.toJSON(list).toString();

            TreeMap<Object, Object> treeMap = new TreeMap<Object, Object>();
            treeMap.put("channel_code", channelCode);//标识第三方
            treeMap.put("request_number", "MKB"+System.currentTimeMillis());//用来匹配请求的 唯一
            treeMap.put("timestamp", (System.currentTimeMillis()/1000));//当前unix时间戳 10位的 秒
            treeMap.put("store_code", "Z155601443729553023");//商场给每家租户分配的店铺号
            treeMap.put("trade_no", "1905140012345677");//交易单号 唯一
            treeMap.put("trade_type", "1");//1正常销售 2退货
            treeMap.put("trade_time", (System.currentTimeMillis()/1000));//交易时间 时间戳  10位的 秒
            treeMap.put("trade_total", "1.23");//交易金额 保留两位小数
            treeMap.put("pay_type", "1");//1现金2支付宝3微信4QQ钱包5京东钱包6银行卡刷卡7银联二维码8其他
            treeMap.put("people_num", "1");//购买人数/就餐人数 若无默认给1
            treeMap.put("software_name", "sm_mkb2.0");//交易时sass软件名称
            treeMap.put("software_spec", "sm_mkb2.0");//软件规格
            treeMap.put("hardware_name", "G3C025Z2M19200042");//交易时硬件名称
            treeMap.put("hardware_spec", "G3C025Z2M19200042");//硬件规格名
            treeMap.put("order_goodlist", goodDetailStr);//商品列表

            String sign = buildParamSign(treeMap,key);//表单数据拼接，计算签名

            treeMap.put("sign",sign);//请求签名用来验证请求的合法性

            JSONObject jsonObject = (JSONObject)JSONObject.toJSON(treeMap);
            String str = postForJson(url,jsonObject);

            System.out.println(str);
            JSONObject resJson = (JSONObject) JSON.parse(str);
            System.out.println(resJson.getString("code"));
            System.out.println(resJson.getString("message"));
            System.out.println(resJson.getString("request_number"));

        }catch (Exception e){
            e.printStackTrace();
        }
    }
	
	
	
	
	
	
	
	
	
	
	
    /**
     * 采用POST请求，数据格式为 application/json，并且返回结果是JSON string
     * @param url
     * @param
     * @return
     */
    public static String postForJson(String url,JSONObject json){
        RestTemplate restTemplate = new RestTemplate();
        //设置Http Header
        HttpHeaders headers = new HttpHeaders();
        //设置请求媒体数据类型
        headers.setContentType(MediaType.APPLICATION_JSON_UTF8);
        //设置返回媒体数据类型
        headers.add("Accept", MediaType.APPLICATION_JSON.toString());
        HttpEntity<String> formEntity = new HttpEntity<String>(json.toString(), headers);
        return restTemplate.postForObject(url, formEntity, String.class);
    }
    
    
    
    
    
    /**
     * 表单参数拼接
     * 计算签名
     */
    @SuppressWarnings("rawtypes")
	public static String buildParamSign(TreeMap<Object, Object> parameters,String key) throws Exception {
        try {
            //拼接签名字符串
            StringBuilder sb = new StringBuilder();
            Set es = parameters.entrySet();
            Iterator it = es.iterator();
            while(it.hasNext()) {
                Map.Entry entry = (Map.Entry) it.next();
                String k = (String) entry.getKey();
                Object v = entry.getValue();
                if(null != v && !"".equals(v)  && !"{}".equals(v) && !"sign".equals(k)) {
                    sb.append(k + "=" + v + "&");
                }
            }
            //MD5 计算签名
            String signStr = sb+"key="+key;
            System.out.println(signStr);
            return MD5.md5New(signStr).toUpperCase();
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("数据拼接异常");
        }
    }

}
