package com.sunmi.demo.merch_data;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.sunmi.demo.merch_data.utils.HttpClientUtils;
import com.sunmi.demo.merch_data.utils.MD5;
	
public class AppTest {
	public static void main(String[] args) {
		// 检查是商户是否存在
		//checkMchExist();
		//创建商户
		//createMch();
		//订购软件许可
		orderAuth();

	}
	
	
	/**
	 * 检查是商户是否存在
	 */
	public static void  checkMchExist() {
        String channelCode = "SUNMI";
        String key = "6c3b9e65fc41fd232b2140b575";
        String url = "https://taskservice.hbbyun.com:1964/checkMchExist";

        try {
            TreeMap<String, String> treeMap = new TreeMap<String, String>();
            treeMap.put("channel_code", channelCode);//标识第三方
            treeMap.put("request_number", "MKB"+System.currentTimeMillis());//用来匹配请求的 唯一
            treeMap.put("timestamp",  String.valueOf((System.currentTimeMillis()/1000)));//当前unix时间戳 10位的 秒
            treeMap.put("company_name", "中文名公司名称");//公司名称,和营业执照一致。
            treeMap.put("mobile", "12312341234");//手机号
            String sign = buildParamSign(treeMap,key);//表单数据拼接，计算签名
            treeMap.put("sign",sign);//请求签名用来验证请求的合法性
            String str= HttpClientUtils.doPost(url, treeMap);
            System.out.println(str);
            JSONObject resJson = (JSONObject) JSON.parse(str);
            System.out.println(resJson.getString("code"));
            System.out.println(resJson.getString("message"));
            System.out.println(resJson.getString("timestamp"));
            System.out.println(resJson.getString("status"));

        }catch (Exception e){
            e.printStackTrace();
        }
	}
	
	
	
	
	
	
	/**
	 * 创建商户
	 */
    public static void createMch(){
        String channelCode = "SUNMI";
        String key = "6c3b9e65fc41fd232b2140b575";
        String url = "https://taskservice.hbbyun.com:1964/createMch";

        try {
            TreeMap<String, String> treeMap = new TreeMap<String, String>();
            treeMap.put("channel_code", channelCode);//标识第三方
            treeMap.put("request_number", "MKB"+System.currentTimeMillis());//用来匹配请求的 唯一
            treeMap.put("timestamp",  String.valueOf((System.currentTimeMillis()/1000)));//当前unix时间戳 10位的 秒
            treeMap.put("company_name", "中文名公司名称");//公司名称,和营业执照一致。
            treeMap.put("store_name", "中文名门店名称");//默认门店名
            treeMap.put("trade_type_id", "34");//行业类别id
            treeMap.put("trade_type_name", "餐饮");//行业类别名
            treeMap.put("address", "地址123");//地址
            treeMap.put("contactor", "张三");//联系人
            treeMap.put("mobile", "12312341234");//手机号
            treeMap.put("password", "1234567q");//密码
            treeMap.put("email", "565371903@qq.com");//邮箱
            treeMap.put("remark", "dddd");//备注
            treeMap.put("payment_mode", "1");//门店业态 
            
            String sign = buildParamSign(treeMap,key);//表单数据拼接，计算签名
            treeMap.put("sign",sign);//请求签名用来验证请求的合法性
            String str= HttpClientUtils.doPost(url, treeMap);
            System.out.println(str);
            JSONObject resJson = (JSONObject) JSON.parse(str);
            System.out.println(resJson.getString("code"));
            System.out.println(resJson.getString("message"));
            System.out.println(resJson.getString("timestamp"));
            System.out.println(resJson.getString("mch_id"));
            System.out.println(resJson.getString("company_name"));
            System.out.println(resJson.getString("store_id"));
            System.out.println(resJson.getString("store_name"));
            System.out.println(resJson.getString("login_username"));
            System.out.println(resJson.getString("login_password"));
            System.out.println(resJson.getString("login_other"));
        }catch (Exception e){
            e.printStackTrace();
        }
    }
	
	
	
	
	
	
	
	/**
	 * 订购软件许可
	 */
    public static void orderAuth(){
        String channelCode = "SUNMI";
        String key = "6c3b9e65fc41fd232b2140b575";
        String url = "https://taskservice.hbbyun.com:1964/orderAuth";

        try {
            TreeMap<String, String> treeMap = new TreeMap<String, String>();
            treeMap.put("channel_code", channelCode);//标识第三方
            treeMap.put("request_number", "MKB"+System.currentTimeMillis());//用来匹配请求的 唯一
            treeMap.put("timestamp",  String.valueOf((System.currentTimeMillis()/1000)));//当前unix时间戳 10位的 秒
            treeMap.put("mch_id", "123433");//商户id
            treeMap.put("app_code", "121122");//软件规格号
            treeMap.put("app_num", "3");//数量
            String sign = buildParamSign(treeMap,key);//表单数据拼接，计算签名
            treeMap.put("sign",sign);//请求签名用来验证请求的合法性
            String str= HttpClientUtils.doPost(url, treeMap);
            System.out.println(str);
            JSONObject resJson = (JSONObject) JSON.parse(str);
            System.out.println(resJson.getString("code"));
            System.out.println(resJson.getString("message"));
            System.out.println(resJson.getString("timestamp"));
            System.out.println(resJson.getString("mch_id"));
            System.out.println(resJson.getString("auth_list"));
        }catch (Exception e){
            e.printStackTrace();
        }
    }
    
    
    
    
    
    /**
     * 表单参数拼接
     * 计算签名
     */
    @SuppressWarnings("rawtypes")
	public static String buildParamSign(TreeMap<String, String> parameters,String key) throws Exception {
        try {
            //拼接签名字符串
            StringBuilder sb = new StringBuilder();
            Set es = parameters.entrySet();
            Iterator it = es.iterator();
            while(it.hasNext()) {
                Map.Entry entry = (Map.Entry) it.next();
                String k = (String) entry.getKey();
                Object v = entry.getValue();
                if(null != v && !"".equals(v)  && !"{}".equals(v) && !"sign".equals(k)) {
                    sb.append(k + "=" + v + "&");
                }
            }
            //MD5 计算签名
            String signStr = sb+"key="+key;
            System.out.println(signStr);
            return MD5.md5New(signStr).toUpperCase();
        } catch (Exception e) {
            e.printStackTrace();
            throw new Exception("数据拼接异常");
        }
    }

}
